RectangleMorph subclass: #NmUrlMorph
	instanceVariableNames: 'url textMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-WorldMap'!

!NmUrlMorph methodsFor: 'accessing' stamp: 'ns 9/17/2002 16:38'!
authority
	^ url authority! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'ns 9/17/2002 16:38'!
port
	^ url port! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'ns 9/17/2002 13:50'!
text
	^ textMorph contents asString! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'ns 9/17/2002 13:49'!
url
	^ url! !

!NmUrlMorph methodsFor: 'accessing' stamp: 'ns 9/19/2002 19:56'!
url: anUrl 
	| string |
	url _ anUrl.
	(url authority isNil
			or: [url authority isEmpty])
		ifTrue: [^ self text: String new].
	string _ url authority , String cr , url port printString.
	self text: string! !


!NmUrlMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultCellWidth
	^ self class defaultCellWidth! !

!NmUrlMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultExistsColor
	^ self class defaultExistsColor! !

!NmUrlMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 17:14'!
defaultMapColor
	^ self class defaultMapColor! !


!NmUrlMorph methodsFor: 'dropping/grabbing' stamp: 'ka 1/10/2003 12:44'!
wantsToBeDroppedInto: aMorph 
	(aMorph isKindOf: NmWorldMapRowMorph)
		ifFalse: [^ false].
	^ true! !


!NmUrlMorph methodsFor: 'initialization' stamp: 'ns 10/8/2002 16:06'!
initialize
	"NmUrlMorph new."
	super initialize.
	"url _ NmUrl createLocal."
	url _ NmUrl new.
	textMorph _ TextMorph new contents: '        '.
	textMorph centered.
	textMorph borderWidth: 4.
	textMorph borderColor: Color transparent.
	textMorph width: self defaultCellWidth.
	textMorph lock.
	self addMorphCentered: textMorph;
		 clipSubmorphs: true;
		 setBorderStyle: #complexAltInset.
	self color: self defaultMapColor;
		 width: self defaultCellWidth! !


!NmUrlMorph methodsFor: 'private' stamp: 'ns 9/19/2002 19:57'!
text: aText 
	textMorph contents: aText asString.
	textMorph position: bounds center - (textMorph extent // 2).
	textMorph lock.
	self setBalloonText: aText.
	textMorph contents isEmpty
		ifTrue: [textMorph contents: '        '.
			self setBorderStyle: #complexAltInset.
			self color: self defaultMapColor]
		ifFalse: [self color: self defaultExistsColor.
			self setBorderStyle: #complexAltRaised]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmUrlMorph class
	instanceVariableNames: ''!

!NmUrlMorph class methodsFor: 'scripting' stamp: 'ns 9/17/2002 15:49'!
additionsToViewerCategories
	^ #(#additionsToViewerCategoryBasic #additionsToViewerCategoryScripts #additionsToViewerCategoryColorAndBorder #additionsToViewerCategoryGeometry #additionsToViewerCategoryMiscellaneous #additionsToViewerCategoryButton #additionsToViewerCategoryMotion #additionsToViewerCategoryObservation #additionsToViewerCategoryPenUse #additionsToViewerCategoryLayout #additionsToViewerCategoryDragAndDrop #additionsToViewerCategoryScripting #additionsToViewerCategoryTests #additionsToViewerCategoryNmUrl )
		select: [:aSelector | self respondsTo: aSelector]
		thenCollect: [:aSelector | self perform: aSelector]! !

!NmUrlMorph class methodsFor: 'scripting' stamp: 'ns 10/8/2002 16:02'!
additionsToViewerCategoryNmUrl
	"Answer viewer additions for the 'URL' category"

	^#(
		URL 
		(
"			(slot url 'url' String	readWrite Player getUrl Player setUrl:)"
			(slot authority 'authority' String	readWrite Player getAuthority Player setAuthority:)
"			(slot path 'path' String	readWrite Player getPath Player setPath:)"
			(slot port 'port' Number readWrite Player getPort Player  setPort:)
			(slot ipAddress 'ip address' String readOnly Player getIpAddress unused  unused)
		)
	)
! !

!NmUrlMorph class methodsFor: 'scripting' stamp: 'ns 9/20/2002 12:09'!
additionsToViewerCategoryNmUrlDeluxe
	"Answer viewer additions for the 'URL' category"

	^#(
		URL 
		(
			(slot url 'url' String	readWrite Player getUrl Player setUrl:)
			(slot fragment 'fragment' String	readWrite Player getFragment Player setFragment:)
			(slot scheme 'scheme' String	readWrite Player getScheme Player setScheme:)
			(slot authority 'authority' String	readWrite Player getAuthority Player setAuthority:)
			(slot path 'path' String	readWrite Player getPath Player setPath:)
			(slot query 'query' String	readWrite Player getQuery Player setQuery:)
			(slot port 'port' Number readWrite Player getPort Player  setPort:)
			(slot realm 'realm' String	readWrite Player getRealm Player setRealm:)
		)
	)
! !


!NmUrlMorph class methodsFor: 'instance creation' stamp: 'ns 9/17/2002 17:13'!
defaultExistsColor
	^ Color tan! !

!NmUrlMorph class methodsFor: 'instance creation' stamp: 'ns 9/17/2002 17:09'!
url: anUrl 
	| urlMorph |
	urlMorph _ self new.
	urlMorph url: anUrl.
	^ urlMorph! !


!NmUrlMorph class methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultCellWidth
	^ 75! !

!NmUrlMorph class methodsFor: 'constants' stamp: 'ns 9/17/2002 17:13'!
defaultMapColor
	^ Color lightGray! !


AlignmentMorph subclass: #NmWorldMapMorph
	instanceVariableNames: 'column startPoint dicDiff '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-WorldMap'!

!NmWorldMapMorph methodsFor: 'initialization' stamp: 'ns 10/8/2002 16:35'!
createWindow
	| window |
	window _ (self defaultOwnerClass labelled: 'WorldMap')
				model: Model new.
	window
		addMorph: self
		frame: (0 @ 0 corner: 1 @ 1).
	self prepareOpen.
	window minimumExtent: self minimumExtent.
	window extent: self minimumExtent.
	window layoutChanged.
	^ window! !

!NmWorldMapMorph methodsFor: 'initialization' stamp: 'ns 9/17/2002 12:22'!
initialize
	super initialize.
	self fillStyle: self mapMorphFillStyle.
	self hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	borderWidth _ 2.
	self listDirection: #topToBottom.
	self cornerStyle: #square.
	self layoutInset: 4.
	self addButtonRow.
	self addMap.
	self fullBounds! !

!NmWorldMapMorph methodsFor: 'initialization' stamp: 'ns 10/8/2002 16:36'!
openInWorld
	"NmWorldMapMorph new openInWorld."
	self createWindow openInWorldExtent: self minimumExtent! !


!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:21'!
backgroundColor
	^ Color gray: 0.9! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:21'!
buttonFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.742
							g: 0.903
							b: 1.0). 1.0
					-> (Color
							r: 0.516
							g: 0.71
							b: 1.0)}.
	fill origin: self bounds topLeft + (14 @ 3).
	fill direction: 8 @ 6.
	fill radial: false.
	^ fill! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/11/2002 19:29'!
defaultButtonClass
	^ SimpleButtonMorph! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/11/2002 18:22'!
defaultCellWidth
	^ 75! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/11/2002 18:06'!
defaultExistsColor
	^ Color tan! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ka 1/10/2003 12:05'!
defaultInset
	^ self class defaultInset! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/11/2002 18:06'!
defaultMapColor
	^ Color lightGray! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:21'!
defaultOwnerClass
	^ SystemWindow! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:22'!
mapMorphFillStyle
	| fill |
	fill _ GradientFillStyle ramp: {0.0
					-> (Color
							r: 0.355
							g: 0.548
							b: 1.0). 1.0
					-> (Color
							r: 0.774
							g: 0.935
							b: 1.0)}.
	fill origin: self bounds topLeft + (61 @ 7).
	fill direction: 33 @ 37.
	fill radial: false.
	^ fill! !

!NmWorldMapMorph methodsFor: 'constants' stamp: 'ns 9/17/2002 12:22'!
minimumExtent
	| width height |
	width _ height _ 0.
	self submorphs
		do: [:each | 
			width _ width max: each extent x.
			height _ height + each extent y].
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [height _ height + self owner labelHeight + 20.
			width _ width + 20].
	^ width @ height! !


!NmWorldMapMorph methodsFor: 'action' stamp: 'ns 9/17/2002 12:21'!
actionClose
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [^ self owner closeBoxHit].
	^ self delete! !

!NmWorldMapMorph methodsFor: 'action' stamp: 'ns 9/17/2002 12:21'!
actionLoad
	| savedBounds newWorldMapMorph |
	savedBounds _ self bounds.
	self actionClose.
	newWorldMapMorph _ NmWorldMapMorph new.
	newWorldMapMorph bounds: savedBounds.
	newWorldMapMorph openInWorld! !

!NmWorldMapMorph methodsFor: 'action' stamp: 'mu 1/17/2003 14:24'!
actionStore
	| columnSize index dic savedBounds newWorldMapMorph |
	columnSize _ column submorphs size.
	index _ startPoint y.
	dic _ Dictionary new.
	columnSize
		to: 1
		by: -1
		do: [:y | 
			| alignmentMorph cellsize | 
			alignmentMorph _ column submorphs at: y.
			cellsize _ alignmentMorph submorphs size.
			1
				to: cellsize
				do: [:x | 
					| urlMorph | 
					urlMorph _ alignmentMorph submorphs at: x.
					(urlMorph port notNil
							and: [urlMorph authority notNil])
						ifTrue: [| point url | 
							point _ x @ index.
							point _ point + startPoint - (1 @ 0).
							url _ urlMorph url.
							dic at: point put: url]].
			index _ index + 1].
	dicDiff
		keysAndValuesDo: [:point :url | dic at: point put: url].
	NmWorldMap map: dic.
	NmWorldMap store.
	savedBounds _ self bounds.
	self actionClose.
	newWorldMapMorph _ NmWorldMapMorph new.
	newWorldMapMorph bounds: savedBounds.
	newWorldMapMorph openInWorld! !


!NmWorldMapMorph methodsFor: 'event handling' stamp: 'ns 9/11/2002 18:59'!
handlesMouseDown: evt 
	^ true! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'ka 1/10/2003 15:07'!
morphToGrab: event
	| morphs morph |
	morphs _ self morphsAt: event position.
	morphs isEmpty
		ifTrue: [^ nil].
	morph _ morphs first.
	(morph isKindOf: TextMorph)
		ifTrue: [^ morph owner].
	(morph isMemberOf: BorderedMorph)
		ifTrue: [^ morph].
	(morph isKindOf: AlignmentMorph)
		ifTrue: [(morph submorphOfClass: self defaultButtonClass) notNil
				ifTrue: [^ nil]
				ifFalse: [(morph submorphOfClass: AlignmentMorph) notNil
						ifTrue: [^ nil]
						ifFalse: [^ morph]]].
	^ nil! !

!NmWorldMapMorph methodsFor: 'event handling' stamp: 'ns 9/13/2002 17:11'!
mouseDown: evt
	"Handle a mouse down event."
	| grabbedMorph handHadHalos |
	grabbedMorph _ self morphToGrab: evt.
	grabbedMorph ifNotNil:[
		grabbedMorph isSticky ifTrue:[^self].
		self isPartsBin ifFalse:[ | result | 
			result _ evt hand grabMorph: grabbedMorph.
			^ result].
		grabbedMorph _ grabbedMorph partRepresented duplicate.
		grabbedMorph restoreSuspendedEventHandler.
		(grabbedMorph fullBounds containsPoint: evt position) 
			ifFalse:[grabbedMorph position: evt position].
		"Note: grabbedMorph is ownerless after duplicate so use #grabMorph:from: instead"
		^evt hand grabMorph: grabbedMorph from: self].
	(super handlesMouseDown: evt)
		ifTrue:[^super mouseDown: evt].
	handHadHalos _ evt hand halo notNil.
	evt hand halo: nil. "shake off halos"
	evt hand releaseKeyboardFocus. "shake of keyboard foci"
	evt shiftPressed ifTrue:[
		^evt hand 
			waitForClicksOrDrag: self 
			event: evt 
			selectors: { #findWindow:. nil. nil. #dragThroughOnDesktop:}
			threshold: 5].
	self isWorldMorph ifTrue: [
		handHadHalos ifTrue: [^self addAlarm: #invokeWorldMenu: with: evt after: 200].
		^self invokeWorldMenu: evt
	].
	"otherwise, explicitly ignore the event if we're not the world,
	so that we could be picked up if need be"
	self isWorldMorph ifFalse:[evt wasHandled: false].
! !


!NmWorldMapMorph methodsFor: 'private' stamp: 'ns 9/17/2002 12:21'!
addButtonRow
	| morph |
	morph _ AlignmentMorph newRow vResizing: #shrinkWrap;
				 color: Color transparent.
	morph
		addMorphBack: (self buttonName: 'Store' action: #actionStore).
	morph addMorphBack: (Morph new extent: 4 @ 1;
			 color: Color transparent).
	morph
		addMorphBack: (self buttonName: 'Close' action: #actionClose).
	morph addMorphBack: (Morph new extent: 4 @ 1;
			 color: Color transparent).
	morph
		addMorphBack: (self buttonName: 'Load' action: #actionLoad).
	morph color: self backgroundColor.
	morph setBorderStyle: #complexAltInset.
	morph borderWidth: 4.
	self addMorphBack: morph! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'ka 1/10/2003 12:03'!
addMap
	| xCol yCol map xMax xMin yMax yMin urlMorph displayedURLDic |
	column _ self makeColumn.
	xCol _ OrderedCollection new.
	yCol _ OrderedCollection new.
	[NmWorldMap load]
		on: Error
		do: [self inform: 'WorldMap loading failed!!'.
			^ self].
	map _ NmWorldMap map.
	map
		keysDo: [:each | 
			xCol add: each x.
			yCol add: each y].
	xMax _ (xCol
				detectMax: [:x | x])
				min: 3.
	xMin _ xCol
				detectMin: [:x | x].
	yMax _ (yCol
				detectMax: [:y | y])
				min: 4.
	yMin _ yCol
				detectMin: [:y | y].
	startPoint _ xMin @ yMin.
	displayedURLDic _ Dictionary new.
	yMin
		to: yMax
		do: [:y | 
			| row | 
			row _ self makeRow.
			xMin
				to: xMax
				do: [:x | 
					| url | 
					url _ map
								at: x @ y
								ifAbsent: [].
					urlMorph _ NmUrlMorph new.
					url isNil
						ifFalse: [| key balloonText ipAddress | 
							displayedURLDic at: x @ y put: url.
							key _ url authority , String cr , url port printString.
							ipAddress _ url ipAddress.
							ipAddress
								ifNil: [ipAddress _ NmUtil unresolvedIPAddressString].
							balloonText _ key , String cr , ipAddress , String cr , (x @ y) printString.
							urlMorph url: url.
							urlMorph setBalloonText: balloonText;
								 yourself].
					row addMorphBack: urlMorph].
			column addMorph: row].
	dicDiff _ map
				reject: [:each | displayedURLDic includes: each].
	column layoutChanged.
	self addMorphBack: column! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'ns 9/13/2002 14:55'!
buttonName: aString action: aSymbol 
	^ self defaultButtonClass new target: self;
		 label: aString;
		 actionSelector: aSymbol;
		
		color: (Color gray: 0.8);
		 fillStyle: self buttonFillStyle;
		 borderWidth: 4;
		 borderColor: #complexAltRaised;
		 cornerStyle: #square! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'ka 1/10/2003 11:53'!
makeColumn
	"self basicNew makeColumn"
	column _ AlignmentMorph newColumn.
	column cellInset: self defaultInset;
		 layoutInset: self defaultInset.
	column enableDragNDrop; vResizing: #shrinkWrap; hResizing: #shrinkWrap; layoutInset: self defaultInset; borderColor: Color black; borderWidth: 1; wrapCentering: #left; cellPositioning: #topLeft.
	column enableDragNDrop: true.
	column setBorderStyle: #complexAltInset.
	column borderWidth: 4.
	column color: self backgroundColor.
	^ column! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'ka 1/10/2003 12:11'!
makeRow
	"self basicNew makeRow openInHand"
	^ self class makeRow! !

!NmWorldMapMorph methodsFor: 'private' stamp: 'ns 9/17/2002 12:22'!
prepareOpen
	(self owner isKindOf: self defaultOwnerClass)
		ifTrue: [| closeButtonMorph | 
			closeButtonMorph _ self allMorphs
						detect: [:each | (each isKindOf: self defaultButtonClass)
								and: [each actionSelector == #actionClose]]
						ifNone: [].
			closeButtonMorph notNil
				ifTrue: [closeButtonMorph delete]]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMapMorph class
	instanceVariableNames: 'soleInstance '!

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'ns 9/17/2002 12:19'!
createWindow
	| window |
	window _ self new createWindow.
	^ window! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'ka 12/19/2002 15:28'!
new
	soleInstance isNil
		ifTrue: [soleInstance _ self basicNew].
	soleInstance initialize.
	ActiveWorld restoreMorphicDisplay.
	^ soleInstance! !

!NmWorldMapMorph class methodsFor: 'instance creation' stamp: 'ns 9/12/2002 11:37'!
open
	^ NmWorldMapMorph new openInWorld! !


!NmWorldMapMorph class methodsFor: 'constants' stamp: 'ka 1/10/2003 12:26'!
defaulfRowExtent
	^ 93 @ 58! !

!NmWorldMapMorph class methodsFor: 'constants' stamp: 'ka 1/10/2003 12:05'!
defaultInset
	^ 16! !


!NmWorldMapMorph class methodsFor: 'parts bin' stamp: 'ka 1/10/2003 14:43'!
makeRow
	"self makeRow openInHand"
	| row |
	row _ NmWorldMapRowMorph newRow.
	row cellInset: self defaultInset;
		 layoutInset: self defaultInset.
	row enableDragNDrop; vResizing: #shrinkWrap; hResizing: #shrinkWrap; layoutInset: 8; borderColor: Color black; borderWidth: 1; wrapCentering: #left; cellPositioning: #topLeft.
	row setBorderStyle: #complexFramed.
	row extent: self defaulfRowExtent.
	^ row! !


AlignmentMorph subclass: #NmWorldMapRowMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Morphic-WorldMap'!

!NmWorldMapRowMorph methodsFor: 'dropping/grabbing' stamp: 'ka 1/10/2003 14:49'!
wantsToBeDroppedInto: aMorph 
	(aMorph isKindOf: AlignmentMorph)
		ifFalse: [^ false].
	(aMorph owner isKindOf: NmWorldMapMorph)
		ifFalse: [^ false].
	^ true! !
