Model subclass: #NmAbstractSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmAbstractSettings class
	instanceVariableNames: 'properties '!

!NmAbstractSettings class methodsFor: 'class initialization' stamp: 'ns 1/22/2003 18:42'!
initialize
	"NmSettings initialize"
	properties _ nil.
	self resetDefaults! !

!NmAbstractSettings class methodsFor: 'class initialization' stamp: 'kuri-t 2/20/2003 16:13'!
resetDefaults
	| keys |
	keys _ self properties keys.
	keys
		do: [:eachKey | self properties removeKey: eachKey].
	keys
		do: [:eachKey | self perform: #changed: with: eachKey asSymbol]! !


!NmAbstractSettings class methodsFor: 'accessing' stamp: 'ns 1/22/2003 19:14'!
properties
	properties ifNil: [properties _ NmProperties new].
	^properties! !


!NmAbstractSettings class methodsFor: 'storing/loading' stamp: 'ns 1/22/2003 18:44'!
load
	"NmSettings load"
	| readFileStream |
	(FileDirectory default fileExists: self iniFileName) ifFalse: [self store].
	readFileStream _ FileDirectory default readOnlyFileNamed: self iniFileName.
	Transcript cr; show: '## NmSetting was loaded: ', self iniFileName.
	^Object readSixxFrom: readFileStream contents.
	! !

!NmAbstractSettings class methodsFor: 'storing/loading' stamp: 'ns 1/22/2003 18:46'!
store 
	"NmSettings store"
	| writeFileStream |
	writeFileStream _ FileDirectory default forceNewFileNamed: self iniFileName.
	writeFileStream nextPutAll: self sixxString.
	writeFileStream close.! !


!NmAbstractSettings class methodsFor: 'constants' stamp: 'ns 1/22/2003 18:48'!
iniFileName
	^self name, '.ini' copy! !


AlignmentMorph subclass: #NmAbstractSettingsMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

!NmAbstractSettingsMorph methodsFor: 'actions' stamp: 'ns 1/22/2003 17:23'!
save
	self settingClass store! !


!NmAbstractSettingsMorph methodsFor: 'testing' stamp: 'ns 1/22/2003 16:35'!
isOn
	^false! !


!NmAbstractSettingsMorph methodsFor: 'testing' stamp: 'ns 1/22/2003 16:35'!
isOn
	^false! !

!NmAbstractSettingsMorph methodsFor: '-- all --' stamp: 'mu 2/19/2003 15:55'!
resetDefaults
	self settingClass resetDefaults.
	"self delete"! !

!NmAbstractSettingsMorph methodsFor: 'actions' stamp: 'ns 1/22/2003 17:23'!
save
	self settingClass store! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmAbstractSettingsMorph class
	instanceVariableNames: ''!

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'ns 1/22/2003 16:35'!
buildMapButtonRowOn: morph

	| store load inspect viewMap row |
	store _ (PluggableButtonMorph on: morph getState: #isOn action: #storeMap) label: 'Store Map'.
	load _ (PluggableButtonMorph on: morph getState: #isOn action: #loadMap) label: 'Load Map'.
	inspect _ (PluggableButtonMorph on: morph getState: #isOn action: #inspectMap) label: 'I'.
	viewMap _ (PluggableButtonMorph on: morph getState: #isOn action: #viewMap) label: 'M'.

	store
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'store WorldMap'.
	load
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'load WorldMap'.
	
	inspect
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'inspect WorldMap'.

	viewMap
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'view WorldMap'.

	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		addAllMorphs: (Array with: store with: load with: inspect with: viewMap);
		extent: 100@35.
	
	^row! !

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'mu 2/19/2003 15:43'!
buildResetDefaultButtonRowOn: morph
	| default row |
	default _ (PluggableButtonMorph on: morph getState: #isOn action: #resetDefaults) label: 'Reset to default values'.

	default
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		setBalloonText: 'set NmSettings to default values'.

	row _ AlignmentMorph newRow
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		addAllMorphs: (Array with: default );
		extent: 120@35.
	
	^row! !

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'ns 1/22/2003 16:35'!
buildRowLabeled: labelName 
	| rowMorph label |
	rowMorph _ AlignmentMorph newRow vResizing: #shrinkWrap.
	label _ TextMorph new contents: labelName;
				 lock.
	rowMorph addMorphBack: label.
	^ rowMorph! !

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'ns 1/22/2003 16:43'!
buildTextField: selector 
	| getter setter textField |
	getter _ selector.
	setter _ (getter , ':') asSymbol.
	textField _ PluggableTextMorph
				on: self settingClass
				text: getter
				accept: setter.
	textField acceptOnCR: true.
	textField hideScrollBarIndefinitely.
	textField borderWidth: 1.
	(textField findDeeplyA: TextMorphForEditView)
		wrapFlag: false.
	textField hResizing: #spaceFill;
		 vResizing: #spaceFill.
	^ textField! !

!NmAbstractSettingsMorph class methodsFor: 'private' stamp: 'ns 1/22/2003 17:18'!
createSystemWindow
	"NmAbstractSettingMorph createSystemWindow openInWorld."
	| inst window |
	inst _ self new.
	inst listDirection: #topToBottom.
	inst hResizing: #shrinkWrap;
		 vResizing: #shrinkWrap.
	window _ (SystemWindow labelled: self labelString)
				model: Model new.
	window
		addMorph: inst
		frame: (0 @ 0 corner: 1 @ 1).
	window extent: self windowExtent.
	^ window! !


!NmAbstractSettingsMorph class methodsFor: 'instance creation' stamp: 'ns 1/22/2003 16:52'!
open
	"NmSettingMorph open"
	^ self createWindow openInWorldExtent: self windowExtent! !

!NmAbstractSettingsMorph class methodsFor: 'instance creation' stamp: 'ns 1/22/2003 16:45'!
windowExtent
	self subclassResponsibility! !


!NmAbstractSettingsMorph class methodsFor: 'factory' stamp: 'ns 1/22/2003 16:41'!
settingClass
	self subclassResponsibility! !


Object subclass: #NmCSVReadWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmCSVReadWriter class
	instanceVariableNames: ''!

!NmCSVReadWriter class methodsFor: 'actions' stamp: 'mu 2/19/2003 18:09'!
csvStringFrom: mapDictionary 
	| stream |
	stream _ WriteStream on: String new.
	mapDictionary
		keysAndValuesDo: [:key :value | 
			stream nextPutAll: key asString.
			stream nextPut: $,.
			stream nextPutAll: value asString.
			stream nextPut: Character cr].
	^ stream contents! !

!NmCSVReadWriter class methodsFor: 'actions' stamp: 'mu 1/23/2003 19:44'!
parseCSVString: aString
	| newMap stream |
	newMap := Dictionary new.
	stream _ ReadStream on: aString.
	[stream atEnd]
		whileFalse: [| line lineStream key value | 
			line _ stream nextLine.
			(line includes: $,)
				ifTrue: [lineStream _ ReadStream on: line.
					key _ (lineStream upTo: $,) withBlanksTrimmed.
					value _ lineStream upToEnd withBlanksTrimmed.
					newMap at: key put: value]].
	^newMap! !


Error subclass: #NmError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!


Object subclass: #NmFlapSetup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!
!NmFlapSetup commentStamp: '<historical>' prior: 0!
To add aMorph to NetMorph Flap;

1)	make a morph.
2)	add the definition to NmFlapSetup class>>quadsDefiningNetMorphFlap.
3)	do "NmFlapSetup reInstall.".

Browser newOnClass: NmFlapSetup class selector: #quadsDefiningNetMorphFlap!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmFlapSetup class
	instanceVariableNames: ''!

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'ns 2/14/2003 14:05'!
addFlap
	"NmFlapSetup addFlap."
	| aFlapTab |
	(ActiveWorld submorphs
			detect: [:each | (each isKindOf: FlapTab)
					and: [each flapID = self tabName]]
			ifNone: []) notNil
		ifTrue: [^ nil].
	aFlapTab _ self newNetMorphFlap.
	aFlapTab setBalloonText: self balloonTextForFlaps.
	Flaps addGlobalFlap: aFlapTab.
	ActiveWorld addGlobalFlaps.
	aFlapTab
		changeTabText: (Vocabulary eToyVocabulary translatedWordingFor: self tabName asSymbol).
	^ aFlapTab! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'ns 2/14/2003 13:38'!
destroyFlap
	"NmFlapSetup destroyFlap."
	"PartsBin initialize."
	(ActiveWorld flapTabs
		select: [:each | each flapID = self tabName])
		do: [:each | each destroyFlap]! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'kuri-t 2/20/2003 12:26'!
reInstall
	"NmFlapSetup reInstall."
	NmFlapSetup destroyFlap.
	PartsBin initialize.
	NmFlapSetup addFlap! !

!NmFlapSetup class methodsFor: 'class initialization' stamp: 'ns 10/7/2002 16:59'!
setUp
	| aFlapTab |
	(aFlapTab _ ActiveWorld submorphs
					detect: [:each | (each isKindOf: FlapTab)
							and: [each flapID = NmFlapSetup tabName]]
					ifNone: []) isNil
		ifFalse: [aFlapTab isGlobalFlap
				ifTrue: [Flaps removeFlapTab: aFlapTab keepInList: false.
					aFlapTab currentWorld reformulateUpdatingMenus]
				ifFalse: [aFlapTab referent isInWorld
						ifTrue: [aFlapTab referent delete].
					aFlapTab delete]].
	PartsBin initialize.
	NmFlapSetup initialize! !


!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 9/13/2002 15:11'!
balloonTextForFlaps
	^ 'NetMorph tools!!' copy! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 9/13/2002 15:12'!
flapColor
	^ Color
		r: 0.516
		g: 0.452
		b: 1.0! !

!NmFlapSetup class methodsFor: 'constans' stamp: 'ns 2/14/2003 13:22'!
tabSymbol
	^ #NetMorph! !


!NmFlapSetup class methodsFor: 'predefined flaps' stamp: 'mu 2/19/2003 14:37'!
quadsDefiningNetMorphFlap
	^ NmServerManager isWarpServerInstalled
		ifTrue: [NmServerManager isMapAndNameServersInstalled
				ifTrue: [self quadsDefiningNetMorphFlapForClientServer]
				ifFalse: [self quadsDefiningNetMorphFlapForClient]]
		ifFalse: [self quadsDefiningNetMorphFlapForServer]! !


!NmFlapSetup class methodsFor: 'private' stamp: 'ns 9/13/2002 15:22'!
newNetMorphFlap
	| aFlapTab aStrip |
	aStrip _ PartsBin newPartsBinWithOrientation: #leftToRight from: self quadsDefiningNetMorphFlap.
	aFlapTab _ FlapTab new referent: aStrip beSticky.
	aFlapTab
		setName: self tabName
		edge: #bottom
		color: self flapColor.
	aStrip extent: self currentWorld width @ 78.
	aFlapTab position: 104 @ (self currentWorld height - aFlapTab height).
	aStrip beFlap: true.
	aStrip color: self flapColor.
	aStrip autoLineLayout: true.
	^ aFlapTab! !

!NmFlapSetup class methodsFor: 'private' stamp: 'ns 1/23/2003 18:39'!
quadsDefiningNetMorphFlapForClient
	"Answer a fully-instantiated flap named 'NetMorph' to be placed at the bottom of the screen, for use when it is the only flap shown upon web launch"
		"class					makeThumbnail		nameInFlap		ballonText"
	^ #(
		(NmSettingsMorph		createWindow			'Setting'			'NetMorph settings')
		(NmWorldMapMorph	createWindow			'WorldMap'		'organize the World Map')
		(NmUrlMorph			authoringPrototype	'URL'				'an URL')
		(NmWorldMapMorph	makeRow				'WorldMap Row'				'a row of the WorldMap')
	)! !

!NmFlapSetup class methodsFor: 'private' stamp: 'mu 2/19/2003 14:38'!
quadsDefiningNetMorphFlapForClientServer
	^self quadsDefiningNetMorphFlapForClient, self quadsDefiningNetMorphFlapForServer
! !

!NmFlapSetup class methodsFor: 'private' stamp: 'kuri-t 2/20/2003 12:17'!
quadsDefiningNetMorphFlapForServer
	"Answer a fully-instantiated flap named 'NetMorph' to be placed at the bottom of the screen, for use when it is the only flap shown upon web launch"
		"class					makeThumbnail		nameInFlap		ballonText"
	^ #(
		(NmServerSettingsMorph		createWindow			'Server Setting'			'NetMorph Server settings')
	)! !

!NmFlapSetup class methodsFor: 'private' stamp: 'ns 2/14/2003 13:23'!
tabName
	^ self tabSymbol! !


Notification subclass: #NmNotification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!


Object subclass: #NmProperties
	instanceVariableNames: 'dictionary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!
!NmProperties commentStamp: '<historical>' prior: 0!
I represent an appication specific name/value properties.

My subclasses will have many default value provider methods. 
Or just use #at: #at:put like a normal dictionary.

#creator
[:masashi | ^umezawa] 
#version 0.4 M.U. 11/21/1999 22:12!


!NmProperties methodsFor: 'initialize-release' stamp: 'ns 1/20/2003 18:45'!
initialize
	"do nothing"! !


!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey 
	^ self dictionary
		at: aKey
		ifAbsent: []! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey ifAbsent: aBlock 
	^ self dictionary at: aKey ifAbsent: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:45'!
at: aKey ifAbsentPut: aBlock 
	^ self dictionary at: aKey ifAbsentPut: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
at: aKey ifAbsentPutValue: aValue 
	^ self dictionary
		at: aKey
		ifAbsent: [self dictionary at: aKey put: aValue]! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
at: aKey put: aValue 
	| val |
	val _ aValue.
	"for self class >> newFrom: aKeyValueArray"
	aValue == #true
		ifTrue: [val _ true].
	aValue == #false
		ifTrue: [val _ false].
	aValue == #nil
		ifTrue: [val _ nil].
	^ self dictionary at: aKey put: val! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
disable: aKey 
	^ self at: aKey put: false! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
enable: aKey 
	^ self at: aKey put: true! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
includesKey: aKey 
	^ self dictionary includesKey: aKey! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
inherit: aNmProperties 
	aNmProperties
		keysAndValuesDo: [:key :value | self at: key ifAbsentPutValue: value]! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
keys
	^ self dictionary keys! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
overridden: aNmProperties 
	aNmProperties
		keysAndValuesDo: [:key :value | self at: key put: value]! !

!NmProperties methodsFor: 'actions' stamp: 'mu 2/12/2003 16:53'!
removeKey: aKey
	^ self dictionary
		removeKey: aKey! !

!NmProperties methodsFor: 'actions' stamp: 'mu 2/12/2003 16:53'!
removeKey: aKey ifAbsent: aBlock
	^ self dictionary
		removeKey: aKey ifAbsent: aBlock! !

!NmProperties methodsFor: 'actions' stamp: 'ns 1/20/2003 18:46'!
size
	^ self dictionary size! !


!NmProperties methodsFor: 'converting' stamp: 'ns 1/20/2003 18:46'!
asArray
	| idx outArr |
	idx _ 0.
	outArr _ Array new: self size.
	self dictionary
		associationsDo: [:assoc | outArr
				at: (idx _ idx + 1)
				put: (Array with: assoc key with: assoc value)].
	^ outArr! !

!NmProperties methodsFor: 'converting' stamp: 'ns 1/20/2003 18:46'!
fromArray: aKeyValueArray 
	"brace expressions are no longer used for Squeak 2.7+: M.U. 11/21/1999 22:15"
	"instead use: #(#(key1 value1) #(key2 value2))"
	| dict |
	dict _ self defaultDictionaryClass new: aKeyValueArray size.
	aKeyValueArray
		do: [:each | dict at: each first put: each last].
	self dictionary: dict! !


!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
do: aBlock 
	^ self dictionary do: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
keysAndValuesDo: aBlock 
	^ self dictionary keysAndValuesDo: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
keysDo: aBlock 
	^ self dictionary keysDo: aBlock! !

!NmProperties methodsFor: 'enumerating' stamp: 'ns 1/20/2003 18:46'!
valuesDo: aBlock 
	^ self dictionary valuesDo: aBlock! !


!NmProperties methodsFor: 'accessing' stamp: 'ns 1/20/2003 18:46'!
dictionary
	dictionary isNil
		ifTrue: [dictionary _ self defaultDictionaryClass new].
	^ dictionary! !

!NmProperties methodsFor: 'accessing' stamp: 'ns 1/20/2003 18:46'!
dictionary: aValue 
	dictionary _ aValue! !


!NmProperties methodsFor: 'factory' stamp: 'ns 1/20/2003 18:46'!
defaultDictionaryClass
	^ IdentityDictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmProperties class
	instanceVariableNames: ''!

!NmProperties class methodsFor: 'instance creation' stamp: 'ns 1/20/2003 18:45'!
new
	^ super new initialize! !

!NmProperties class methodsFor: 'instance creation' stamp: 'ns 1/20/2003 18:45'!
newFrom: aKeyValueArray 
	"brace expressions are no longer used for Squeak 2.7+: M.U. 11/21/1999 22:15"
	"instead use: #(#(key1 value1) #(key2 value2))"
	^ self new fromArray: aKeyValueArray! !


!NmProperties class methodsFor: 'examples' stamp: 'ns 1/20/2003 18:45'!
example1
	"NmProperties example1"
	| props |
	props _ NmProperties newFrom: #(#(#SqIsCool #true) #(#defaultPassword #fooBar) #(#greeting 'Hi!!') ).
	^ props! !

!NmProperties class methodsFor: 'examples' stamp: 'ns 1/20/2003 18:45'!
example2
	"NmProperties example2"
	| props |
	props _ self example1.
	props disable: #SqIsCool.
	^ props
		overridden: (NmProperties newFrom: #(#(#SqueakVersion 2.7) #(#greeting 'Hello!!') ))! !


Object subclass: #NmServerManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmServerManager class
	instanceVariableNames: ''!

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 18:44'!
isMapAndNameServersInstalled
	"NmServerManager isMapAndNameServersInstalled"
	^ ((Smalltalk includesKey: #SoapTransportSetup)
			and: [Smalltalk includesKey: #NmWorldMapServer])
		and: [Smalltalk includesKey: #NmNameResolverServer]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 18:44'!
isMapServerRunning
	"NmServerManager isMapServerRunning"
	| setup |
	(setup _ self soapTransportSetup)
		ifNil: [^ false].
	^ setup runningTransportNames includes: NmServerSettings mapServerTransportProtocol! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 18:45'!
isNameResolverServerRunning
	"NmServerManager isNameResolverServerRunning"
	| setup |
	(setup _ self soapTransportSetup)
		ifNil: [^ false].
	^ setup runningTransportNames includes: NmSettings nameResolverTransportProtocol! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 18:45'!
isWarpServerInstalled
	"NmServerManager isWarpServerInstalled"
	^ Smalltalk includesKey: #NmRemoteServer! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 18:45'!
startMapServer
	"NmServerManager startMapServer"
	| setup |
	(setup _ self soapTransportSetup)
		ifNotNil: [setup
				stop: (Array with: NmServerSettings mapServerTransportProtocol).
			setup restartAt: NmServerSettings mapServerTransportProtocol port: NmServerSettings mapServerPort]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 18:45'!
startNameResolverServer
	"NmServerManager startNameResolverServer"
	| setup |
	(setup _ self soapTransportSetup)
		ifNotNil: [setup
				stop: (Array with: NmServerSettings nameResolverTransportProtocol).
			setup restartAt: NmServerSettings nameResolverTransportProtocol port: NmServerSettings nameResolverServerPort]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 12:27'!
startWarpServer
	| setup |
	(setup _ self warpTransportSetup)
		ifNotNil: [NmUtil stopWarpServer.
			setup default restart: NmSettings warpPort]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 18:45'!
stopMapServer
	"NmServerManager stopMapServer"
	| setup |
	(setup _ self soapTransportSetup)
		ifNotNil: [setup
				stop: (Array with: NmServerSettings mapServerTransportProtocol)]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 18:45'!
stopNameResolverServer
	"NmServerManager stopNameResolverServer"
	| setup |
	(setup _ self soapTransportSetup)
		ifNotNil: [setup
				stop: (Array with: NmServerSettings nameResolverTransportProtocol)]! !

!NmServerManager class methodsFor: 'server administration' stamp: 'ns 1/23/2003 12:27'!
stopWarpServer
	| setup openSockets |
	(setup _ self warpTransportSetup)
		ifNotNil: [setup default stop.
			openSockets _ Socket allInstances
						select: [:each | each isConnected].
			(openSockets
				select: [:each | each remotePort = NmSettings warpPort])
				do: [:each | each closeAndDestroy]]! !


!NmServerManager class methodsFor: 'factory' stamp: 'ns 1/23/2003 12:27'!
soapTransportSetup
	^ Smalltalk
		at: #SoapTransportSetup
		ifAbsent: []! !

!NmServerManager class methodsFor: 'factory' stamp: 'ns 1/23/2003 12:27'!
warpTransportSetup
	^ Smalltalk
		at: #NmRemoteServer
		ifAbsent: []! !


HttpUrl subclass: #NmUrl
	instanceVariableNames: 'isLocal '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 15:35'!
host
	self authority isNil ifTrue: [authority _  ''].
	^self authority	! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/3/2002 10:26'!
host: aString 
	
	authority _ aString! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 16:36'!
isLocal
	isLocal isNil
		ifTrue: [isLocal _ false].
	^ isLocal! !

!NmUrl methodsFor: 'accessing' stamp: 'MU 10/1/2002 16:36'!
isLocal: aBoolean
	isLocal _ aBoolean! !

!NmUrl methodsFor: 'accessing' stamp: 'mu 1/17/2003 14:49'!
port: anInteger
	port _ anInteger! !


!NmUrl methodsFor: 'comparing' stamp: 'MU 10/3/2002 10:33'!
= otherNmUrl 
	"'nm://localhost' asUrl = 'nm://127.0.0.1' asUrl"
	self class = otherNmUrl class ifFalse: [^ false].
	self port = otherNmUrl port ifFalse: [^ false].
	self path = otherNmUrl path ifFalse: [^ false].
	^ self hostId = otherNmUrl hostId! !

!NmUrl methodsFor: 'comparing' stamp: 'MU 10/3/2002 10:33'!
hash
	^ (self port hash hashMultiply + self path hash hashMultiply + self hostId hash hashMultiply) 




! !

!NmUrl methodsFor: 'comparing' stamp: 'MU 11/11/2002 16:07'!
hostId

	^ self hostOrIpAddress asString, ':', self port asString! !

!NmUrl methodsFor: 'comparing' stamp: 'MU2 1/21/2003 18:40'!
port
	port ifNil: [port _ NmSettings defaultWarpPort].
	^ port.! !

!NmUrl methodsFor: 'comparing' stamp: 'mu 10/7/2002 15:20'!
truelyEquals: otherNmUrl 
	self class = otherNmUrl class
		ifFalse: [^ false].
	self authority = otherNmUrl authority
		ifFalse: [^ false].
	self port = otherNmUrl port
		ifFalse: [^ false].
	self path = otherNmUrl path
		ifFalse: [^ false].
	self ipAddress = otherNmUrl ipAddress
		ifFalse: [^ false].
	^ true! !


!NmUrl methodsFor: 'printing' stamp: 'MU 11/11/2002 15:55'!
csvString
	"'nm://localhost:37458' asUrl csvString"
	| stream |
	stream _ WriteStream on: String new.
	stream nextPutAll: self printString.
	^ stream contents! !

!NmUrl methodsFor: 'printing' stamp: 'MU 10/3/2002 10:22'!
displayString
	^ (self authority isNil
			or: [self port isNil])
		ifTrue: [String new]
		ifFalse: [super toText]! !

!NmUrl methodsFor: 'printing' stamp: 'MU2 1/21/2003 18:40'!
shortPrintString
	"'nm://localhost:37459' asUrl shortPrintString"
	"'nm://localhost:37458' asUrl shortPrintString"
	| stream |
	stream _ WriteStream on: String new.
	stream nextPutAll: self host.
	self port = NmSettings defaultPort
		ifFalse: [stream nextPut: $:.
			stream nextPutAll: self port printString].
	^ stream contents! !


!NmUrl methodsFor: 'printing-sixx'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self toText.! !


!NmUrl methodsFor: 'testing' stamp: 'MU 11/11/2002 16:09'!
isIPAddressedUrl
	^ (NetNameResolver addressFromString: self host) notNil! !


!NmUrl methodsFor: 'initialize-release' stamp: 'MU 10/3/2002 10:43'!
initialize
	path _ #()! !

!NmUrl methodsFor: 'initialize-release' stamp: 'MU 11/11/2002 16:18'!
privateInitializeFromText: aString 
	
	super privateInitializeFromText: aString.

	"set host if possible"
	authority _ authority asLowercase.
	authority = '127.0.0.1'
		ifTrue: [authority _ 'localhost']
		ifFalse: [ | tokens | 
				tokens _ authority findTokens: '.'.
				(tokens
					select: [:each | each isAllDigits
							and: [each asNumber < 256]]) size = 4
				ifTrue: [| hostname | 
					hostname _ NetNameResolver
								nameForAddress: (NetNameResolver addressFromString: authority)
								timeout: 15.
					authority _ hostname isNil
								ifFalse: [hostname asLowercase]]]! !


!NmUrl methodsFor: 'actions' stamp: 'mu 10/8/2002 15:32'!
hostOrIpAddress
	^ self ipAddress isNil
		ifTrue: [self host]
		ifFalse: [self ipAddress]! !

!NmUrl methodsFor: 'actions' stamp: 'MU 11/11/2002 15:51'!
ipAddress
	^ NmNameResolver default
		resolve: self host
		ifAbsent: [nil]! !

!NmUrl methodsFor: 'actions' stamp: 'mu 10/28/2002 16:58'!
resolve
	NmNameResolver default
		resolve: self host
		ifAbsent: []! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmUrl class
	instanceVariableNames: 'local '!

!NmUrl class methodsFor: 'constants'!
protcolIdentifier
	^ 'nm' copy.! !


!NmUrl class methodsFor: 'instance creation-sixx'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self absoluteFromText: (SixxXmlUtil characterDataFrom: sixxElement)! !


!NmUrl class methodsFor: 'instance creation' stamp: 'MU2 1/21/2003 18:40'!
createLocal
	"NmUrl local"
	| url |
	url _ (self protcolIdentifier , '://' , NmUtil localHostname , ':' , NmSettings warpPort printString) asUrl.
	^ url! !

!NmUrl class methodsFor: 'instance creation' stamp: 'MU 11/11/2002 15:57'!
fromCSVString: aString 
	"NmUrl fromCSVString: 'nm://localhost:37458/'"
	| stream urlString url |
	stream _ ReadStream on: aString.
	urlString _ stream upToEnd.
	url _ urlString asUrl.
	^ url! !

!NmUrl class methodsFor: 'instance creation' stamp: 'MU 10/2/2002 20:26'!
new
	^super new initialize! !


!NmUrl class methodsFor: 'accessing' stamp: 'MU 10/3/2002 10:19'!
local
	local isNil ifTrue: [local _ self createLocal].
	^local! !


!NmUrl class methodsFor: 'claass initialization' stamp: 'MU 10/3/2002 12:44'!
initialize
	"NmUrl initialize"
	local _ nil! !


NmCSVReadWriter subclass: #NmWorldMapReadWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'NM-Support-Common'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NmWorldMapReadWriter class
	instanceVariableNames: ''!

!NmWorldMapReadWriter class methodsFor: 'private' stamp: 'mu 2/21/2003 14:59'!
mapPath
	NmServerManager isMapAndNameServersInstalled ifTrue: [^NmServerSettings mapPath].
	^NmSettings mapPath! !

!NmWorldMapReadWriter class methodsFor: 'private' stamp: 'ns 1/23/2003 14:38'!
randomPointFrom: existingPoints 

	|  maxPoint minPoint xSize ySize points |
	
	maxPoint _ existingPoints inject: 0@0 into: [:sum :eachPoint | sum max: eachPoint ].
	minPoint _ existingPoints inject: maxPoint into: [:sum :eachPoint | sum min: eachPoint ]. 
	
	xSize _ (maxPoint x - minPoint x) + 1.
	ySize _ (maxPoint y - minPoint y) + 1.
	
	points _ OrderedCollection new: (xSize * ySize).
	minPoint x to: maxPoint x do: [:x |
		minPoint y to: maxPoint y do: [:y |
			points add: (Point x: x y: y)]].

	points removeAll: existingPoints.
	points isEmpty ifTrue: [^nil].
	^points atRandom! !


!NmWorldMapReadWriter class methodsFor: 'actions' stamp: 'mu 2/19/2003 18:10'!
csvStringFrom: mapDictionary 
	| stream |
	stream _ WriteStream on: String new.
	mapDictionary
		keysAndValuesDo: [:key :value | 
			stream nextPutAll: key printString.
			stream nextPut: $,.
			stream nextPutAll: value csvString.
			stream nextPut: Character cr].
	^ stream contents! !

!NmWorldMapReadWriter class methodsFor: 'actions' stamp: 'mu 2/21/2003 15:00'!
getMapStringFromFile: mapName 
	| readDir fileName |
	fileName _ (mapName endsWith: '.csv')
				ifTrue: [mapName]
				ifFalse: [mapName , '.csv'].
	readDir _ FileDirectory on: self mapPath.
	(readDir fileExists: fileName)
		ifTrue: [| fileStream mapCSVString | 
			[fileStream _ readDir readOnlyFileNamed: fileName.
			mapCSVString _ fileStream contentsOfEntireFile]
				ensure: [fileStream
						ifNotNil: [fileStream close]].
			^ mapCSVString]
		ifFalse: [^ nil]! !

!NmWorldMapReadWriter class methodsFor: 'actions' stamp: 'ns 1/23/2003 11:31'!
listAllMapNamesFromDirectory
	| readDir | 
	readDir _ FileDirectory on: NmServerSettings mapPath.
	(readDir directoryExists: readDir pathName)
		ifTrue: [| fileNames mapNames | 
			fileNames _ readDir fileNames. 
			mapNames _ fileNames
						select: [:each | '*.csv' match: each].
			^ mapNames]
		ifFalse: [^ #()]! !

!NmWorldMapReadWriter class methodsFor: 'actions' stamp: 'mu 1/23/2003 19:42'!
parseCSVString: aString
	| newMap stream |
	newMap := Dictionary new.
	stream _ ReadStream on: aString.
	[stream atEnd]
		whileFalse: [| line lineStream url point | 
			line _ stream nextLine.
			(line includes: $,)
				ifTrue: [lineStream _ ReadStream on: line.
					point _ Point readFrom: ((lineStream upTo: $,) withBlanksTrimmed).
					url _ lineStream upToEnd withBlanksTrimmed asUrl.
					newMap at: point put: url]].
	^newMap! !

!NmWorldMapReadWriter class methodsFor: 'actions' stamp: 'mu 2/21/2003 14:59'!
putMapString: mapCSVString toFile: mapName 
	| writeFileStream fileName |
	fileName _ (mapName endsWith: '.csv')
				ifTrue: [mapName]
				ifFalse: [mapName , '.csv'].
	[writeFileStream _ (FileDirectory on: self mapPath)
				forceNewFileNamed: fileName.
	writeFileStream
		ifNil: [self error: 'Wrong path or filename'.
			^ nil].
	writeFileStream nextPutAll: mapCSVString]
		ensure: [writeFileStream
				ifNotNil: [writeFileStream close]].
	! !

!NmWorldMapReadWriter class methodsFor: 'actions' stamp: 'ns 1/23/2003 14:38'!
registerAddress: nmURLString toFile: mapName 
	| mapCSV mapDict newPoint newCSV |
	mapCSV _ self getMapStringFromFile: mapName.
	mapCSV
		ifNil: [^ nil].
	mapDict _ self parseCSVString: mapCSV.
	newPoint _ self randomPointFrom: mapDict keys.
	newPoint
		ifNil: [^ nil].
	mapDict at: nmURLString put: newPoint.
	newCSV _ self csvStringFrom: mapDict.
	self putMapString: newCSV toFile: mapName.
	^ newPoint! !

!NmWorldMapReadWriter class methodsFor: 'actions' stamp: 'ns 1/23/2003 11:31'!
storeMap: map toFile: mapName 
	| writeFileStream fileName |
	fileName _ (mapName endsWith: '.xml')
				ifTrue: [mapName]
				ifFalse: [mapName , '.xml'].
	[writeFileStream _ (FileDirectory on: NmServerSettings mapPath)
				forceNewFileNamed: fileName.
	writeFileStream ifNil:[self error:'Wrong path or filename'. ^self].
	writeFileStream nextPutAll: map sixxString]
		ensure: [writeFileStream ifNotNil:[writeFileStream close]]! !

NmAbstractSettings initialize!
NmUrl initialize!